package com.example.prapro2spring.controller;

import com.example.prapro2spring.dto.ActivityLogDTO;
import com.example.prapro2spring.model.ActivityLog;
import com.example.prapro2spring.service.ActivityLogService;
import com.example.prapro2spring.service.ActivityLogDTOService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/activityLogs")
public class ActivityLogController {

    @Autowired
    private ActivityLogService activityLogService;
    @Autowired
    private ActivityLogDTOService activityLogDTOService;

    @GetMapping
    public List<ActivityLog> getAllActivityLogs() {
        return activityLogService.findAll();
    }

    @GetMapping("/{id}")
    public ActivityLog getActivityLogById(@PathVariable Integer id) {
        return activityLogService.findById(id).orElse(null);
    }

    @PostMapping
    public ActivityLogDTO createActivityLog(@RequestBody ActivityLogDTO activityLog) {
        activityLog.setId(null);
        return activityLogDTOService.save(activityLog);
    }

    @PutMapping("/{id}")
    public ActivityLogDTO updateActivityLog(@PathVariable Integer id, @RequestBody ActivityLogDTO activityLogDetails) {
        ActivityLogDTO activityLog = activityLogDTOService.findById(id).orElse(null);
        if (activityLog != null) {
            activityLog.setActivityId(activityLogDetails.getActivityId());
            activityLog.setPersonId(activityLogDetails.getPersonId());
            activityLog.setStartTimestamp(activityLogDetails.getStartTimestamp());
            activityLog.setEndTimestamp(activityLogDetails.getEndTimestamp());
            return activityLogDTOService.save(activityLog);
        }
        return null;
    }

    @DeleteMapping("/{id}")
    public void deleteActivityLog(@PathVariable Integer id) {
        activityLogService.deleteById(id);
    }
}