package com.example.prapro2spring.controller;

import com.example.prapro2spring.dto.OccupationLogDTO;
import com.example.prapro2spring.model.OccupationLog;
import com.example.prapro2spring.service.OccupationLogDTOService;
import com.example.prapro2spring.service.OccupationLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/occupationLogs")
public class OccupationLogController {

    @Autowired
    private OccupationLogService occupationLogService;
    @Autowired
    private OccupationLogDTOService occupationLogDTOService;

    @GetMapping
    public List<OccupationLog> getAllOccupationLogs() {
        return occupationLogService.findAll();
    }

    @GetMapping("/{id}")
    public OccupationLog getOccupationLogById(@PathVariable Integer id) {
        return occupationLogService.findById(id).orElse(null);
    }

    @PostMapping
    public OccupationLogDTO createOccupationLog(@RequestBody OccupationLogDTO occupationLog) {
        occupationLog.setId(null);
        return occupationLogDTOService.save(occupationLog);
    }

    @PutMapping("/{id}")
    public OccupationLogDTO updateOccupationLog(@PathVariable Integer id, @RequestBody OccupationLogDTO occupationLogDetails) {
        OccupationLogDTO occupationLog = occupationLogDTOService.findById(id).orElse(null);
        if (occupationLog != null) {
            occupationLog.setOccupationId(occupationLogDetails.getOccupationId());
            occupationLog.setPersonId(occupationLogDetails.getPersonId());
            occupationLog.setStartTimestamp(occupationLogDetails.getStartTimestamp());
            occupationLog.setEndTimestamp(occupationLogDetails.getEndTimestamp());
            occupationLog.setGrade(occupationLogDetails.getGrade());
            return occupationLogDTOService.save(occupationLog);
        }
        return null;
    }

    @DeleteMapping("/{id}")
    public void deleteOccupationLog(@PathVariable Integer id) {
        occupationLogService.deleteById(id);
    }
}