TRUNCATE TABLE people_scoreboard.activity_log;
TRUNCATE TABLE people_scoreboard.occupation_log;
TRUNCATE TABLE people_scoreboard.people cascade;
TRUNCATE TABLE people_scoreboard.activities cascade;
TRUNCATE TABLE people_scoreboard.occupations cascade;

SELECT setval(pg_get_serial_sequence('people_scoreboard.people', 'id'), coalesce(max(id),0) + 1, false) FROM people_scoreboard.people;
SELECT setval(pg_get_serial_sequence('people_scoreboard.activities', 'id'), coalesce(max(id),0) + 1, false) FROM people_scoreboard.activities;
SELECT setval(pg_get_serial_sequence('people_scoreboard.occupations', 'id'), coalesce(max(id),0) + 1, false) FROM people_scoreboard.occupations;
SELECT setval(pg_get_serial_sequence('people_scoreboard.activity_log', 'id'), coalesce(max(id),0) + 1, false) FROM people_scoreboard.activity_log;
SELECT setval(pg_get_serial_sequence('people_scoreboard.occupation_log', 'id'), coalesce(max(id),0) + 1, false) FROM people_scoreboard.occupation_log;

INSERT INTO people_scoreboard.activities (name, value)
VALUES ('Exercising', 5),
       ('Working', 20),
       ('Sleeping', 0),
       ('Eating', 0),
       ('Studying', 15),
       ('Procrastinating', -30),
       ('Praising Government', 50),
       ('Talking about other nations positively', -80),
       ('Conspiring', -500),
       ('Talking about other nations negatively', 100);
INSERT INTO people_scoreboard.occupations (name, value)
VALUES ('Student', 100),
       ('Engineer', 200),
       ('Doctor', 300),
       ('Lawyer', 400),
       ('Teacher', 500),
       ('Unemployed', -100),
       ('Parent', 500);

INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (NULL, NULL, '1980-01-01 00:00:00');
INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (NULL, NULL, '1980-01-01 00:00:00');

INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (1, 2, '2000-01-01 00:00:00');
INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (1, 2, '2002-01-01 00:00:00');
INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (1, 2, '2004-01-01 00:00:00');

INSERT INTO people_scoreboard.people (parent1Id, parent2Id, birth_timestamp)
VALUES (NULL, NULL, '2001-01-01 00:00:00');

INSERT INTO people_scoreboard.people (parent1Id, parent2Id)
VALUES (2, 5);
INSERT INTO people_scoreboard.people (parent1Id, parent2Id)
VALUES (2, 5);

DO
$do$
    DECLARE
        random_activity_id     INT;
        random_occupation_id   INT;
        random_person_id       INT;
        random_start_timestamp TIMESTAMP;
        random_end_timestamp   TIMESTAMP;
    BEGIN
        FOR i IN 1..20
            LOOP -- Insert 100 random rows
        -- Get random activity, occupation, and person IDs
                SELECT floor(random() * 10 + 1)::INT INTO random_activity_id; -- 10 activities
                SELECT floor(random() * 7 + 1)::INT INTO random_occupation_id; -- 7 occupations
                SELECT floor(random() * 6 + 1)::INT INTO random_person_id;
                -- 6 people

                -- Get random start and end timestamps within the last year
                SELECT NOW() - (random() * interval '365 days') INTO random_start_timestamp;
                SELECT random_start_timestamp + (random() * interval '24 hours') INTO random_end_timestamp;

                -- Insert into activity_log
                INSERT INTO people_scoreboard.activity_log (activity_id, human_id, start_timestamp, end_timestamp)
                VALUES (random_activity_id, random_person_id, random_start_timestamp, random_end_timestamp);

                IF i % 2 = 0 THEN
                    -- Insert into occupation_log
                    INSERT INTO people_scoreboard.occupation_log (occupation_id, human_id, start_timestamp, end_timestamp, grade)
                    VALUES (random_occupation_id, random_person_id, random_start_timestamp, random_end_timestamp,
                            floor(random() * 5 + 1)::INT); -- Random grade between 1 and 5
                END IF;
            END LOOP;
    END
$do$;




